<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2006 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/vars.php";
include_once "include/config.php";
include_once "include/profile.php";
include_once "include/calendar.php";
include_once "include/site.php";
include_once "$theme/theme.php";

function add_camera($database, $user_id,
                    $camera_type_id, $camera_manufacturer_id, $camera_model, $camera_variation,
                    $camera_serial_number, $camera_purchase_timestamp,
                    $camera_purchased_new, $camera_access_rights, $camera_icc_profile) {

  $camera_date_of_purchase = check_date_validity($camera_purchase_timestamp);

  $camera_model = pg_escape_string($camera_model);
  $camera_variation = pg_escape_string($camera_variation);
  $camera_serial_number = pg_escape_string($camera_serial_number);

  if ($camera_type_id=='custom') {
    $new_camera_type_id = pg_fetch_row(pg_query($database, "select nextval('camera_type_id_sequence')"));
    $camera_type_id = $new_camera_type_id[0];
    $result = pg_query($database, "insert into camera_type (identifier, manufacturer, model, variation, last_modified_date, last_modifying_users, raw_icc_profile)
                                        values ($camera_type_id, $camera_manufacturer_id, '$camera_model', '$camera_variation', now(), $user_id, $camera_icc_profile)");
    if (!$result) {
      // print "Failed to create new camera type";
      return FALSE;
    }
  }

  $result = pg_query($database, "insert into camera (identifier, type, users, serial_number, date_of_purchase, purchased_new, access_rights)
                                        values (nextval('camera_id_sequence'), '$camera_type_id', '$user_id', '$camera_serial_number', $camera_date_of_purchase, '$camera_purchased_new', '$camera_access_rights')");
  if (!$result) {
    //print "Failed to create new camera";
    return FALSE;
  }
  return TRUE;
}


$database = site_prolog();

if ($po_user['type'] < $user_type['user']) {
  site_epilog($database);
  header("location: login.php");
  exit();
}

add_camera($database, $po_user['id'],
           pg_escape_string($_REQUEST['camera_type_id']),
           pg_escape_string($_REQUEST['camera_manufacturer_id']),
           pg_escape_string($_REQUEST['camera_model']),
           pg_escape_string($_REQUEST['camera_variation']),
           pg_escape_string($_REQUEST['camera_serial_number']),
           pg_escape_string($_REQUEST['camera_purchase_timestamp']),
           pg_escape_string($_REQUEST['camera_purchased_new']),
           pg_escape_string($_REQUEST['camera_access_rights']),
           pg_escape_string($_REQUEST['camera_icc_profile']));
site_epilog($database);
header("location: my.profile.php?selector=".$profile_data['camera']['idx']);
?>
