<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2006 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/vars.php";
include_once "include/config.php";
include_once "$theme/theme.php";
include_once "include/site.php";
include_once "include/common.php";

$database = site_prolog();

if ($po_user['type'] < $user_type['user']) {
  site_epilog($database);
  header("location: login.php");
  exit();
}

$photo_id               = pg_escape_string($_REQUEST['photo']);
$req_keywords           = $_REQUEST['keywords'];
$author                 = pg_escape_string($_REQUEST['author']);
$title                  = pg_escape_string($_REQUEST['title']);
$caption                = pg_escape_string($_REQUEST['caption']);
$caption_writer         = pg_escape_string($_REQUEST['caption_writer']);
$web_statement          = pg_escape_string($_REQUEST['web_statement']);
$copyright              = pg_escape_string($_REQUEST['copyright']);
$supplemental_category  = pg_escape_string($_REQUEST['supplemental_category']);
$category               = substr(pg_escape_string($_REQUEST['category']), 0, 3);
$credit                 = pg_escape_string($_REQUEST['credit']);
$source                 = pg_escape_string($_REQUEST['source']);
$headline               = pg_escape_string($_REQUEST['headline']);
$instructions           = pg_escape_string($_REQUEST['instructions']);
$transmission_reference = pg_escape_string($_REQUEST['transmission_reference']);

$full_date_of_exposure = check_date_validity($_REQUEST['full_date_of_exposure']);
$date_of_exposure = check_date_validity($_REQUEST['exposure_timestamp']);

$location         = pg_escape_string($_REQUEST['location']);
$access_rights    = pg_escape_string($_REQUEST['access_rights']);
$hide_original    = pg_escape_string($_REQUEST['hide_original']);

$camera           = pg_escape_string($_REQUEST['camera']);
$lens             = pg_escape_string($_REQUEST['lens']);
$filter           = pg_escape_string($_REQUEST['filter']);
$film             = pg_escape_string($_REQUEST['film']);
$flash            = pg_escape_string($_REQUEST['flash']);
$scanner          = pg_escape_string($_REQUEST['scanner']);
$focal_length     = pg_escape_string($_REQUEST['focal_length']);
$aperture         = pg_escape_string($_REQUEST['aperture']);
$shutter          = pg_escape_string($_REQUEST['shutter']);
$exp_comp         = pg_escape_string($_REQUEST['exp_comp']);
$exp_diff         = pg_escape_string($_REQUEST['exp_diff']);
$camera_metering  = pg_escape_string($_REQUEST['camera_metering']);
$camera_program   = pg_escape_string($_REQUEST['camera_program']);
$flash_mode       = pg_escape_string($_REQUEST['flash_mode']);
$flash_comp       = pg_escape_string($_REQUEST['flash_comp']);
$scan_resolution  = pg_escape_string($_REQUEST['scan_resolution']);
$scan_bitdepth    = pg_escape_string($_REQUEST['scan_bitdepth']);
$scan_multiscan   = pg_escape_string($_REQUEST['scan_multiscan']);
$iso_override     = pg_escape_string($_REQUEST['iso_override']);
$support          = pg_escape_string($_REQUEST['support']);

$file_type = substr($file_type, strpos($file_type, "/") + 1);
$result = pg_query($database, "begin");

if ($po_user['type'] < $user_type['administrator']) {
  /* Ensure mere users don't move/mangle a photo that isn't theirs! */
  $result = pg_query($database, "select identifier from photo where identifier='$photo_id' and users = $po_user[id]");
  if (pg_num_rows($result) <= 0) {
    site_epilog($database);
    header("location: login.php");
    exit();
  }
 }
}

if (substr($full_date_of_exposure, 0, 16) == substr($date_of_exposure, 0, 16)) {
  $date_of_exposure = $full_date_of_exposure;
}

$query = "update photo
     set location               = $location,
         author                 = '$author',
         title                  = '$title',
         caption                = '$caption',
         caption_writer         = '$caption_writer',
         web_statement          = '$web_statement',
         supplemental_category  = '$supplemental_category',
         copyright_statement    = '$copyright',
         credit                 = '$credit',
         source                 = '$source',
         headline               = '$headline',
         instructions           = '$instructions',
         transmission_reference = '$transmission_reference',
         date_of_exposure       = $date_of_exposure,
         access_rights          = $access_rights,
         hide_original          = '$hide_original'
         where identifier = $photo_id";

$result = pg_query($database, $query);
if (!$result) {
  pg_query($database, "rollback");
  site_epilog($database);
  header("location: photo.php?photo=$photo_id");
  exit();
}

if (pg_num_rows(pg_query($database, "select identifier from photo_tech where photo=$photo_id")) > 0) {
  $result = pg_query($database, "
    update photo_tech
       set camera=$camera,
           lens=$lens,
           film=$film,
           flash=$flash,
           scanner=$scanner,
           filter=$filter,
           scan_resolution=$scan_resolution,
           aperture=$aperture,
           focal_length=$focal_length,
           shutter=$shutter,
           camera_metering=$camera_metering,
           camera_program=$camera_program,
           flash_mode=$flash_mode,
           exposure_comp=$exp_comp,
           flash_comp=$flash_comp,
           ev_difference=$exp_diff,
           iso_override=$iso_override,
           support=$support,
           scan_bitdepth=$scan_bitdepth,
           scan_multiscan=$scan_multiscan
     where photo=$photo_id");
  if (!$result) {
    pg_query($database, "rollback");
    site_epilog($database);
    header("location: photo.php?photo=$photo_id");
    exit();
  }
} else {
  if ($camera != "null"       || $lens != "null"         || $film != "null"            || $flash != "null"           || $support != "null" ||
      $scanner != "null"      || $filter != "null"       || $scan_resolution != "null" || $scan_bitdepth != "null"   || $scan_multiscan != "null" ||
      $aperture != "null"     || $focal_length != "null" || $shutter != "null"         || $camera_metering != "null" || $camera_program != "null" ||
      $flash_mode != "null"   || $exp_comp != "null"     || $flash_comp != "null"      || $exp_diff != "null"        || $iso_override != "null") {
    $result = pg_query($database, "
       insert into photo_tech
              (identifier, photo, camera, lens,  film, flash, scanner,
               filter, scan_resolution, aperture, focal_length, shutter,
               camera_metering, camera_program, flash_mode, exposure_comp,
               flash_comp, ev_difference, iso_override, support, scan_bitdepth,
               scan_multiscan)
       values (nextval('photo_tech_id_sequence'), $photo_id, $camera, $lens, $film, $flash, $scanner,
               $filter, $scan_resolution, $aperture, $focal_length, $shutter,
               $camera_metering, $camera_program, $flash_mode, $exp_comp,
               $flash_comp, $exp_diff, $iso_override, $support, $scan_bitdepth,
               $scan_multiscan)");
    if (!$result) {
      pg_query($database, "rollback");
      site_epilog($database);
      header("location: photo.php?photo=$photo_id");
      exit();
    }
  }
 }

/* keyword update */
$result = pg_query($database, "delete from photo_keywords where photo=$photo_id");
if (!$result) {
  pg_query($database, "rollback");
  site_epilog($database);
  header("location: photo.php?photo=$photo_id");
  exit();
 }

if (strstr($req_keywords, ";")) {
  $keywords = semi_string_to_array($req_keywords);
 } else {
  $keywords = space_string_to_array($req_keywords);
 }

foreach ($keywords as $keyword) {
  $keyword = strtolower(trim($keyword));
  $keyword = trim($keyword, ','); /* Trailing commas */
  $keyword = trim($keyword);
  if ($keyword == "") continue;
  $keyword = pg_escape_string($keyword);
  
  $result = pg_query($database, "insert into photo_keywords (photo, keyword) values ($photo_id, '$keyword')");
  if (!$result) {
    pg_query($database, "rollback");
    site_epilog($database);
    header("location: photo.php?photo=$photo_id");
    exit();
  }
}
 
$result = pg_query($database, "commit");
site_epilog($database);

header("location: photo.php?photo=$photo_id");
?>
