<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2006 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/vars.php";
include_once "include/config.php";
include_once "include/common.php";
include_once "include/site.php";
include_once "include/iptc.php";
include_once "include/orderby.php";
include_once "include/search.2.php";
include_once "$theme/theme.php";

function display_itemized_keyword_list($keywords) {
  global $theme;

  foreach ($keywords as $keyword) {
    print "<input type=\"checkbox\" name=\"keywords[]\" value=\"$keyword\" />$keyword ";
  }
  print "<input type=\"image\" src=\"$theme/button.search.gif\" name=\"search\" value=\"search\" />\n";
}

$photo_id = pg_escape_string($_REQUEST['photo']);
$version  = pg_escape_string($_REQUEST['ver']);
$album_id = pg_escape_string($_REQUEST['album']);
$order_by = pg_escape_string($_REQUEST['order_by']);

$database = site_prolog();

$detail_info="";
$option="";
$album_data="";

if ($photo_id) {
  /* select photo data */
  $version_selector = $version ? "photo_version.identifier=$version" : "photo_version.master='t'";
  $photo_data = pg_fetch_row(pg_query($database, "
    select users, folder, location, caption, date_of_exposure, medium_image_path, large_image_path,
           access_type.identifier, access_type.value, copyright_statement, views,
           11 - (select avg(rating.value) from rating where rating.photo=photo.identifier) as rating,
           hide_original, author, title, '' as keyword,
           caption_writer, category, credit, source,
           headline, instructions, transmission_reference,
           supplemental_category, web_statement, colorspace, orientation
      from photo, photo_version, access_type
     where photo.access_rights = access_type.identifier
       and photo.identifier = photo_version.photo
       and $version_selector
       and photo.identifier = '$photo_id'"));
} else {
  header("HTTP/1.1 404 Not found");
  exit();
}

if (!$photo_data) {
  site_epilog($database);
  exit();
}

$owner_id = $photo_data[0];
if ($owner_id != "" && $po_user['type'] != $user_type['disabled']) {
  $client = pg_fetch_row(pg_query($database, "
    select identifier, trusted
      from client
     where users='$owner_id'
       and client='$po_user[id]'
       and status=2"));
}

/* if the photo is private and isn't mine return */
if (($photo_data[7] == $access['private']) && ($po_user['id'] != $owner_id) && ($po_user['type'] != $user_type['administrator'])) {
  site_epilog($database);
  header("location: login.php");
  exit();
}

if (($photo_data[7] == $access['protected']) && ($po_user['id'] != $owner_id) && ($client == "") && ($po_user['type'] != $user_type['administrator'])) {
  site_epilog($database);
  header("location: login.php");
  exit();
}

if ($po_user['id'] == $owner_id || $po_user['type'] == $user_type['administrator']) {
  $sql_photo_access_rights = "";
  $sql_folder_access_rights = "";
} else {
  if ($po_user['id'])
    $client = pg_fetch_row(pg_query($database, "select identifier from client where users='$owner_id' and client='$po_user[id]' and status=2"));
  else
    $client = "";

  if ($client == "") {
    $sql_photo_access_rights = "and photo.access_rights = $access[public]";
    $sql_folder_access_rights = "and folder.access_rights = $access[public]";
  } else {
    $sql_photo_access_rights = "and photo.access_rights < $access[private]";
    $sql_folder_access_rights = "and folder.access_rights < $access[private]";
  }
}

if (!$order_by) {
  if ($album_id) {
    $tmp = pg_fetch_row(pg_query($database, "select orderby from album where identifier='$album_id'"));
  } else {
    $tmp = pg_fetch_row(pg_query($database, "select orderby from folder where identifier='$photo_data[1]'"));
  }
  $order_by = $tmp[0];
}

$sql_order_by_string = $order_by_string[$order_by][0];
if ($album_id) {
  $photos_in_container = pg_query($database, "
    select photo.identifier,
           11 - (select avg(rating.value) from rating where rating.photo=photo.identifier) as rating,
           views, photo.date_of_exposure, photo_dupe.date_of_creation, original_image_name
      from photo, photo_dupe, album_content, photo_version
     where album_content.photo = photo.identifier
       and album_content.album = $album_id
       and photo.identifier = photo_version.photo
       and photo.identifier = photo_dupe.photo
           $sql_photo_access_rights
     order by $sql_order_by_string");
} else {
  $photos_in_container = pg_query($database, "
    select photo.identifier,
           11 - (select avg(rating.value) from rating where rating.photo=photo.identifier) as rating
      from photo, photo_dupe, photo_version
     where photo.identifier = photo_dupe.photo
       and photo.identifier = photo_version.photo
       and photo.folder = $photo_data[1]
           $sql_photo_access_rights
     order by $sql_order_by_string");
}

$num_of_photos_in_container = pg_num_rows($photos_in_container);
$previous = $photo_id;
for ($i=0; $i < $num_of_photos_in_container; $i++) {
  $tmp = pg_fetch_row($photos_in_container, $i);
  if ($tmp[0] == $photo_id) {
    $i++;
    if ($i < $num_of_photos_in_container) {
      for ($j = $i; $j < $num_of_photos_in_container; $j++) {
        $tmp = pg_fetch_row($photos_in_container, $j);
        if ($tmp[0] == $photo_id)
          continue;
        else
          break;
      }
      $next = $tmp[0];
      break;
    }
    else
      $next = $photo_id;
    break;
  }
  $previous = $tmp[0];
}

if ($po_user['id'] == $owner_id || $po_user['type'] == $user_type['administrator']) {
  $folder_all = pg_query($database, "select identifier, caption, parent_folder from folder where users=$owner_id");
  $album_all = pg_query($database, "select identifier, caption from album where users=$owner_id and type='u' ");
}

$user_data = pg_fetch_row(pg_query($database, "
   select users.identifier, last_name, first_name, shop_enable
     from users, preferences
    where users.preferences=preferences.identifier
      and users.identifier=$owner_id"));
$photo_tech = pg_fetch_row(pg_query($database, "
    select camera, lens, film, flash, scanner, filter, scan_resolution,
           aperture, focal_length, shutter, camera_metering, camera_program,
           flash_mode, exposure_comp, flash_comp, ev_difference, iso_override,
           support, scan_bitdepth, scan_multiscan, exif, iptc
      from photo_tech
     where photo=$photo_id"));

/* Get any keywords for the photo... */
$res = pg_query($database, "select keyword from photo_keywords where photo=$photo_id");
$keywords = FALSE;
for ($i=0; $i < pg_num_rows($res); $i++) {
  $dat = pg_fetch_assoc($res);
  $keywords[] = $dat['keyword'];
 }

$techinfo_tab  = ($photo_tech[7]!=""  || $photo_tech[ 9]!="" || $photo_tech[ 8]!="" || $photo_tech[13]!="" || $photo_tech[15]!="" ||
                  $photo_tech[10]!="" || $photo_tech[11]!="" || $photo_tech[12]!="" || $photo_tech[14]!="" || $photo_tech[ 6]!="" ||
                  $photo_tech[0]!=""  || $photo_tech[ 1]!="" || $photo_tech[ 2]!="" || $photo_tech[ 3]!="" || $photo_tech[ 4]!="" ||
                  $photo_tech[5]!=""  || $photo_tech[16]!="" || $photo_tech[17]!="");

if ($po_user['type'] < $user_type['client'])
     $po_user['id'] = "null";
$all_photo_items_for_sale = pg_query($database, "
    select photo_item.identifier, photo, description, price,
           (select alpha_code from currency where currency.identifier=photo_item.currency),
            comment, photo_item.date_of_creation,
           (select name from currency where currency.identifier=photo_item.currency),
           shop_category.caption,
           (select max(identifier) from shop_order where item=photo_item.identifier and transaction is null) as ordered,
           (select max(download_counter) from shop_order where item=photo_item.identifier and shop_order.client = $po_user[id] and transaction is not null) as counter,
           (select max(download_expiry_date) from shop_order where item=photo_item.identifier and shop_order.client = $po_user[id] and transaction is not null) as expiry_date,
           (select max(shop_order.identifier) from shop_order, shop_transaction, client where shop_order.transaction=shop_transaction.identifier and shop_order.client = client.client and (client.trusted = 't' or shop_transaction.status = '2')) as purchase_confirmed,
           photo_item.deleted
      from photo_item, shop_item, shop_category
     where photo_item.shop_item = shop_item.identifier
       and shop_item.category = shop_category.identifier
       and photo=$photo_id
     order by shop_item.identifier");

$number_of_photos_for_sale = pg_num_rows($all_photo_items_for_sale);

$photo_on_client_order = false;
for ($i=0; $i < $number_of_photos_for_sale; $i++) {
  $photo_for_sale = pg_fetch_row($all_photo_items_for_sale, $i);

  if (!$photo_for_sale[12])
    continue;

  if (($photo_for_sale[10] > 0) && (compare_timestamps(date("Y-m-d H:i:s"), $photo_for_sale[11]) > 0)) {
    $photo_on_client_order = true;
    break;
  }
}

$detail_info = $_REQUEST['detail_info'];

if (!$detail_info)
  $detail_info = 1;

switch ($detail_info) {
case 1:
  break;
case 2:
  if (!(($po_user['id'] == $owner_id) || ($po_user['type'] == $user_type['administrator']) || !$techinfo_tab))
     $detail_info = 1;
  break;
case 3:
  if (!(($po_user['id'] == $owner_id) || ($po_user['type'] == $user_type['administrator'])))
    $detail_info = 1;
  break;
case 4:
  if (!(($po_user['id'] == $owner_id) || ($po_user['type'] == $user_type['administrator'])))
    $detail_info = 1;
  break;
case 5:
  if (!(($po_user['id'] == $owner_id) || ($po_user['type'] == $user_type['administrator'])))
    $detail_info = 1;
  break;
case 6:
  break;
case 7:
  if (!$photo_data[9])
    $detail_info = 1;
  break;
case 8:
  if (!(($po_user['id'] == $owner_id) || (($po_user['type'] >= $user_type['client']) && ($number_of_photos_for_sale > 0)))) {
     $detail_info = 1;
     break;
  }
  if (!(($po_user['id'] == $owner_id) || ($po_user['type'] >= $user_type['client']))) {
     $detail_info = 1;
     break;
  }
  if (($user_data[3]=='f'))
     $detail_info = 1;
  break;
 case 99:
   if (!(($po_user['id'] == $owner_id) || ($po_user['type'] == $user_type['administrator']) || !$techinfo_tab))
     $detail_info = 1;
   break;
default:
  $detail_info = 1;
}

site_header($page_width, "Display Photo");
if ($po_user['id'] == $owner_id) {
  site_navigator(5);
  $user_display_string = "My Folders and Albums";
}
else {
  site_navigator(1);
  $user_display_string = sprintf("%s, %s", $user_data[1], $user_data[2]);
  pg_query($database, "update photo set views=views+1 where identifier=$photo_id");
}

$zanza = strip_tags($photo_data[14] ? $photo_data[14] : $photo_data[3], '<b><i><u>');
$zanza = makeZanza($zanza, "No Title");
$folder_data = pg_fetch_row(pg_query($database, "
  select folder.identifier, folder.caption, folder.access_rights, folder.description
    from folder
   where folder.identifier=$photo_data[1]
         $sql_folder_access_rights"));

$additional_info = "";
$album_info = "";

if ($album_id) {
  $album_data = pg_fetch_row(pg_query($database, "
    select album.identifier, album.caption, album.description
      from album
     where album.identifier=$album_id"));
  $path_info = " : <a href=\"album.php?album=$album_data[0]\">$album_data[1]</a> : ". $zanza;
  if ($folder_data[0])
    $addional_info="This photo is part of folder: <a href=\"folder.php?folder=$folder_data[0]\">$folder_data[1]</a>&nbsp;";
} else {
  if ($folder_data[0]) {
    $path_to_folder = get_path_to_folder($database, $folder_data[0]);
    $path_info = $path_to_folder . " : <a href=\"folder.php?folder=$folder_data[0]\">$folder_data[1]</a> : " . $zanza;
  } else {
    $path_info = " : Hidden Path : " . $zanza;
  }
}

site_navigator_status("<a href=\"user.php\">Users</a> : <a href=\"user.php?user=$user_data[0]\">$user_display_string</a>" . $path_info, $addional_info);

if ($album_id) {
  $option = "&amp;album=$album_id";
}

print "&nbsp;<br/>\n";
print "<table width=\"100%\" border=\"0\" align=\"center\">\n<tr>\n";

print "<td align=\"center\" valign=\"middle\" hight=\"25\" width=\"29\">\n";
if ($photo_id != $previous) {
  $on_mouse_over ="ttOffsetX=12; ttWidth=10; return escape('<img src=image.display.php?image=$previous&amp;size=1 border=0')";
  print "<a class=\"nodecor\" href=\"photo.php?photo=$previous&amp;order_by=$order_by&amp;detail_info=$detail_info$option\"><img src=\"$theme/button.previous.gif\" border=\"0\" alt=\"Previous photo\" onmouseover=\"$on_mouse_over\" /></a>\n";
}
print "</td>\n";
print "<td align=\"center\" valign=\"middle\">\n";

if (grant_access_to_original($photo_data[6] != "",
                             ($po_user['id'] == $owner_id),
			     ($po_user['type'] == $user_type['administrator']),
                             $photo_data[12] == "f",
                             $photo_on_client_order)) {
  display_shaded_photo("image.display.php?image=$photo_id&amp;size=2&amp;ver=$version", "image.display.php?image=$photo_id&amp;size=3&amp;ver=$version", $image_repository_path . "/" . $photo_data[5]);
}
else {
  display_shaded_photo("image.display.php?image=$photo_id&amp;size=2&amp;ver=$version", "", $image_repository_path . "/" . $photo_data[5]);
}
print "</td>";
print "<td align=\"center\" valign=\"middle\" hight=\"25\" width=\"29\">\n";
if ($photo_id != $next) {
  $on_mouse_over ="ttOffsetX=-180; ttWidth=10; return escape('<img src=image.display.php?image=$previous&amp;size=1 border=0')";
  print "<a class=\"nodecor\" href=\"photo.php?photo=$next&amp;order_by=$order_by&amp;detail_info=$detail_info$option\"><img src=\"$theme/button.next.gif\" border=\"0\" alt=\"Next photo\" onmouseover=\"$on_mouse_over\"/></a>\n";
}
print "</td>\n";
print "</tr>\n</table>";

print "&nbsp;<br/>\n";

print "<table cellpadding=\"0\" cellspacing=\"0\" border=\"0\" width=\"100%\">\n";
print "<tr>\n";
print "<td align=\"left\" valign=\"bottom\">\n";
print "<table align=\"left\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\">\n";
print "<tr align=\"left\" valign=\"bottom\">\n";
print "<td>\n";
if ($detail_info == 1) {
  print "<img src=\"$theme/notebook.details.a.gif\" border=\"0\" alt=\"Details\"/>";
}
else {
  print "<a class=\"nodecor\" href=\"photo.php?photo=$photo_id&amp;order_by=$order_by&amp;detail_info=1\">";
  print "<img src=\"$theme/notebook.details.gif\" border=\"0\" alt=\"Details\"/></a>";
}
print "</td>\n";
if (($po_user['id'] == $owner_id || $po_user['type'] == $user_type['administrator']) && $techinfo_tab) {
  print "<td>\n";
  if ($detail_info == 2) {
    print "<img src=\"$theme/notebook.technical.a.gif\" border=\"0\" alt=\"Technical\"/>";
  }
  else {
    print "<a class=\"nodecor\" href=\"photo.php?photo=$photo_id&amp;order_by=$order_by&amp;detail_info=2\">";
    print "<img src=\"$theme/notebook.technical.gif\" border=\"0\" alt=\"Technical\"/></a>";
  }
  print "</td>\n";
}

if ($po_user['id'] == $owner_id || $po_user['type'] == $user_type['administrator']) {
  print "<td>\n";
  if ($detail_info == 5) {
    print "<img src=\"$theme/notebook.version.a.gif\" border=\"0\" alt=\"Version Control\"/>";
  }
  else {
    print "<a class=\"nodecor\" href=\"photo.php?photo=$photo_id&amp;order_by=$order_by&amp;detail_info=5\">";
    print "<img src=\"$theme/notebook.version.gif\"  border=\"0\" alt=\"Version Control\"/></a>";
  }
  print "</td>\n";
}

if ($po_user['id'] == $owner_id || $po_user['type'] == $user_type['administrator']) {
  print "<td>\n";
  if ($detail_info == 3) {
    print "<img src=\"$theme/notebook.duplicates.a.gif\" border=\"0\" alt=\"Duplicates\"/>";
  }
  else {
    print "<a class=\"nodecor\" href=\"photo.php?photo=$photo_id&amp;order_by=$order_by&amp;detail_info=3\">";
    print "<img src=\"$theme/notebook.duplicates.gif\"  border=\"0\" alt=\"Duplicates\"/></a>";
  }
  print "</td>\n";
}

if ($po_user['id'] == $owner_id || $po_user['type'] == $user_type['administrator']) {
  print "<td>\n";
  if ($detail_info == 4) {
    print "<img src=\"$theme/notebook.submissions.a.gif\" border=\"0\" alt=\"Submissions\"/>";
  }
  else {
    print "<a class=\"nodecor\" href=\"photo.php?photo=$photo_id&amp;order_by=$order_by&amp;detail_info=4\">";
    print "<img src=\"$theme/notebook.submissions.gif\"  border=\"0\" alt=\"Submissions\"/></a>";
  }
  print "</td>\n";
}
print "<td>\n";
if ($detail_info == 6) {
  print "<img src=\"$theme/notebook.ratings.a.gif\" border=\"0\" alt=\"Ratings\"/>";
}
else {
  print "<a class=\"nodecor\" href=\"photo.php?photo=$photo_id&amp;order_by=$order_by&amp;detail_info=6\">";
  print "<img src=\"$theme/notebook.ratings.gif\"  border=\"0\" alt=\"Ratings\"/></a>";
}
print "</td>\n";

if ($photo_data[9]) {
  print "<td>\n";
  if ($detail_info == 7) {
    print "<img src=\"$theme/notebook.copyright.a.gif\" border=\"0\" alt=\"Copyright\"/>";
  }
  else {
    print "<a class=\"nodecor\" href=\"photo.php?photo=$photo_id&amp;order_by=$order_by&amp;detail_info=7\">";
    print "<img src=\"$theme/notebook.copyright.gif\"  border=\"0\" alt=\"Copyright\"/></a>";
  }
  print "</td>\n";
}

if ((($po_user['id'] == $owner_id) || (($po_user['type'] >= $user_type['client']) && ($number_of_photos_for_sale > 0) && ($user_data[3]=='t')))) {
  print "<td>\n";
  if ($detail_info == 8) {
    print "<img src=\"$theme/notebook.shop.a.gif\" border=\"0\" alt=\"Shop\"/>";
  }
  else {
    print "<a class=\"nodecor\" href=\"photo.php?photo=$photo_id&amp;order_by=$order_by&amp;detail_info=8\">";
    print "<img src=\"$theme/notebook.shop.gif\"  border=\"0\" alt=\"Shop\"/></a>";
  }
  print "</td>\n";
}

print "</tr>\n";
print "</table>\n";
print "</td>\n";

print "<td align=\"right\">\n";
display_effective_content_search($po_user['session'], $photo_id, "", "");
print "</td>\n";
print "</tr>\n";
print "</table>\n";

print "<form method=\"post\" action=\"photo.move.php\">\n";
print "<input type=\"hidden\" name=\"source_album\" value=\"$album_id\"/>\n";
print "<input type=\"hidden\" name=\"photo_id\" value=\"$photo_id\"/>\n";
print "<input type=\"hidden\" name=\"version\" value=\"$version\"/>\n";
print "<input type=\"hidden\" name=\"user\" value=\"$owner_id\"/>\n";

switch ($detail_info) {
  default:
  case 1:
    print "<table bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"4\" width=\"100%\">\n";
    print "<tr><td align=\"right\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"25%\">Identifier</td>";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$photo_id</td></tr>\n";
    if ($photo_data[14] != "") {
      print "<tr><td align=\"right\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"25%\">Title</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$photo_data[14]</td></tr>\n";
    }
    if ($photo_data[13] != "") {
      print "<tr><td align=\"right\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"25%\">Author</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$photo_data[13]</td></tr>\n";
    }
    if ($keywords != FALSE) {
      print "<tr><td align=\"right\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"25%\">Keywords</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >";
      display_itemized_keyword_list($keywords);
      print "</td></tr>\n";
    }

    if ($photo_data[20] != "") {
      print "<tr><td align=\"right\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"25%\">Headline</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$photo_data[20]</td></tr>\n";
    }
    if ($photo_data[18] != "") {
      print "<tr><td align=\"right\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"25%\">Credit</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$photo_data[18]</td></tr>\n";
    }

    if ($photo_data[16] != "") {
      print "<tr><td align=\"right\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"25%\">Caption Writer</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$photo_data[16]</td></tr>\n";
    }
    if ($photo_data[3] != "") {
      print "<tr><td align=\"right\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"25%\">Caption</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$photo_data[3]</td></tr>\n";
    }
    if ($album_data[2] != "") {
      print "<tr><td align=\"right\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"25%\">Album Description</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$album_data[2]</td></tr>\n";
    }
    if ($folder_data[3] != "") {
      print "<tr><td align=\"right\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"25%\">Folder Description</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$folder_data[3]</td></tr>\n";
    }
    if ($photo_data[17] != "") {
      print "<tr><td align=\"right\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"25%\">Category</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$photo_data[17]</td></tr>\n";
    }
    if ($photo_data[23] != "") {
      print "<tr><td align=\"right\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"25%\">Supplemental Category</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$photo_data[23]</td></tr>\n";
    }

    if ($photo_data[19] != "") {
      print "<tr><td align=\"right\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"25%\">Source</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$photo_data[19]</td></tr>\n";
    }
    if ($photo_data[21] != "") {
      print "<tr><td align=\"right\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"25%\">Instructions</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$photo_data[21]</td></tr>\n";
    }
    if ($photo_data[22] != "") {
      print "<tr><td align=\"right\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"25%\">Transmission Reference</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$photo_data[22]</td></tr>\n";
    }

    if ($photo_data[2]!="") {
      $location = pg_fetch_row(pg_query($database, "select place, city, state, country from view_location where identifier=$photo_data[2]"));
      if ($location[0] != '' && ($location[1] != '' || $location[2] != '' ||  $location[3] != '')) {
        $location[0] = sprintf("%s,", $location[0]);
      }
      if ($location[1] != '' && ($location[2] != '' ||  $location[3] != '')) {
        $location[1] = sprintf("%s,", $location[1]);
      }
      if ($location[2] != '' && $location[3] != '') {
        $location[2] = sprintf("%s,", $location[2]);
      }
      if ($location[0] != "" || $location[1] != "" || $location[2] != "" || $location[3] != "") {
        print "<tr><td align=\"right\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"25%\">Location</td>";
        print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$location[0] $location[1] $location[2] $location[3]</td></tr>\n";
      }
    }
    if ($photo_data[4] != "") {
      print "<tr><td align=\"right\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"25%\">Exposure date</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >";
      if (substr($photo_data[4], 11, 8) != "00:00:00") {
        print generate_date_html($photo_data[4], "full", $po_user['id']  == "" ? 0 : 1);
      }
      else {
        print generate_date_html($photo_data[4], "date", $po_user['id']  == "" ? 0 : 1);
      }
      print "</td></tr>\n";
    }
    if ($photo_data[8] != "") {
      print "<tr><td align=\"right\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"25%\">Access</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$photo_data[8]";
      if ($photo_data[12] == "f")
        print ", original is accessible for authorized users.";
      else
        print ", original is acessible for owner only.";
      print "</td></tr>\n";
    }
    if ($photo_data[10] != "") {
      print "<tr><td align=\"right\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"25%\">Views</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$photo_data[10]</td></tr>\n";
    }

    print "</table>\n";
    break;
 case 2:
    if ($photo_tech[0]!="")  $camera  = pg_fetch_row(pg_query($database, "select name, model, variation from view_camera  where identifier=$photo_tech[0]"));
    if ($photo_tech[1]!="")  $lens    = pg_fetch_row(pg_query($database, "select name, model, variation, s_min_aperture, s_max_aperture, s_min_focal_length, s_max_focal_length from view_lens  where identifier=$photo_tech[1]"));
    if ($photo_tech[2]!="")  $film    = pg_fetch_row(pg_query($database, "select name, model, iso, format from view_film  where identifier=$photo_tech[2]"));
    if ($photo_tech[3]!="")  $flash   = pg_fetch_row(pg_query($database, "select name, model, variation from view_flash   where identifier=$photo_tech[3]"));
    if ($photo_tech[4]!="")  $scanner = pg_fetch_row(pg_query($database, "select name, model, variation from view_scanner where identifier=$photo_tech[4]"));
    if ($photo_tech[5]!="")  $filter  = pg_fetch_row(pg_query($database, "select name, model, variation from view_filter  where identifier=$photo_tech[5]"));
    if ($photo_tech[17]!="") $support = pg_fetch_row(pg_query($database, "select name, model, variation from view_support where identifier=$photo_tech[17]"));

    if ($photo_tech[7]!="")  $aperture        = pg_fetch_row(pg_query($database, "select value from aperture        where identifier=$photo_tech[7]"));
    if ($photo_tech[9]!="")  $shutter         = pg_fetch_row(pg_query($database, "select value from shutter         where identifier=$photo_tech[9]"));
    if ($photo_tech[8]!="")  $focal_length    = pg_fetch_row(pg_query($database, "select value from focal_length    where identifier=$photo_tech[8]"));
    if ($photo_tech[13]!="") $exposure_comp   = pg_fetch_row(pg_query($database, "select value from ev_comp         where identifier=$photo_tech[13]"));
    if ($photo_tech[15]!="") $ev_difference   = pg_fetch_row(pg_query($database, "select value from ev_comp         where identifier=$photo_tech[15]"));
    if ($photo_tech[10]!="") $camera_metering = pg_fetch_row(pg_query($database, "select value from camera_metering where identifier=$photo_tech[10]"));
    if ($photo_tech[11]!="") $camera_program  = pg_fetch_row(pg_query($database, "select value from camera_program  where identifier=$photo_tech[11]"));
    if ($photo_tech[12]!="") $flash_mode      = pg_fetch_row(pg_query($database, "select value from flash_mode      where identifier=$photo_tech[12]"));
    if ($photo_tech[14]!="") $flash_comp      = pg_fetch_row(pg_query($database, "select value from ev_comp         where identifier=$photo_tech[14]"));
    if ($photo_tech[6]!="")  $scan_resolution = pg_fetch_row(pg_query($database, "select value from scan_resolution where identifier=$photo_tech[6]"));
    if ($photo_tech[16]!="") $iso_override    = pg_fetch_row(pg_query($database, "select value from film_iso        where identifier=$photo_tech[16]"));
    if ($photo_tech[18]!="") $scan_bitdepth   = pg_fetch_row(pg_query($database, "select value from scan_bitdepth  where identifier=$photo_tech[18]"));
    if ($photo_tech[19]!="") $scan_multiscan  = pg_fetch_row(pg_query($database, "select value from scan_multiscan where identifier=$photo_tech[19]"));

    print "<table bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"4\" width=\"100%\">\n";
    if ($photo_tech[0]!="") {
      print "<tr><td align=\"right\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"25%\">Camera</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$camera[0] $camera[1] $camera[2]</td></tr>\n";
    }
    if ($photo_tech[10]!="") {
      print "<tr><td align=\"right\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"25%\">Camera Metering</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$camera_metering[0]</td></tr>\n";
    }
    if ($photo_tech[11]!="") {
      print "<tr><td align=\"right\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"25%\">Camera Program</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$camera_program[0]</td></tr>\n";
    }
    if ($photo_tech[1]!="") {
      print "<tr><td align=\"right\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"25%\">Lens</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$lens[0] $lens[1] $lens[2] ";
      display_lens_string($lens[3], $lens[4], $lens[5], $lens[6]);
      print "</td></tr>\n";
    }
    if ($photo_tech[8]!="") {
      print "<tr><td align=\"right\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"25%\">Focal Length</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$focal_length[0]</td></tr>\n";
    }
    if ($photo_tech[5]!="") {
      print "<tr><td align=\"right\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"25%\">Filter</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$filter[0] $filter[1] $filter[2]</td></tr>\n";
    }
    if ($photo_tech[2]!="") {
      print "<tr><td align=\"right\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"25%\">Film</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$film[0] $film[1]";
      if ($film[2]!="") {
        print " ISO $film[2]";
        if ($photo_tech[16]!="") {
          print "; overriden to ISO $iso_override[0]";
        }
      }
      if ($film[3]!="") print ", $film[3]";
      print "</td></tr>\n";
    }
    if ($photo_tech[7]!="") {
      print "<tr><td align=\"right\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"25%\">Aperture</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$aperture[0]</td></tr>\n";
    }
    if ($photo_tech[9]!="") {
      print "<tr><td align=\"right\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"25%\">Shutter Speed</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$shutter[0]</td></tr>\n";
    }
    if ($photo_tech[13]!="") {
      print "<tr><td align=\"right\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"25%\">Exposure Compensation</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$exposure_comp[0]</td></tr>\n";
    }
    if ($photo_tech[15]!="") {
      print "<tr><td align=\"right\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"25%\">Ev Difference</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$ev_difference[0]</td></tr>\n";
    }
    if ($photo_tech[3]!="") {
      print "<tr><td align=\"right\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"25%\">Flash</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$flash[0] $flash[1] $flash[2]</td></tr>\n";
    }
    if ($photo_tech[12]!="") {
      print "<tr><td align=\"right\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"25%\">Flash Mode</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$flash_mode[0]</td></tr>\n";
    }
    if ($photo_tech[14]!="") {
      print "<tr><td align=\"right\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"25%\">Flash Compensation</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$flash_comp[0]</td></tr>\n";
    }
    if ($photo_tech[4]!="") {
      print "<tr><td align=\"right\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"25%\">Scanner</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$scanner[0] $scanner[1] $scanner[2]</td></tr>\n";
    }
    if ($photo_tech[6]!="") {
      print "<tr><td align=\"right\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"25%\">Scan Parameters</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >";
      if ($scan_resolution[0]!="") print "$scan_resolution[0] dpi &nbsp;\n";
      if ($scan_bitdepth[0]!="") print "$scan_bitdepth[0] bits &nbsp;\n";
      if ($scan_multiscan[0]!="") print "$scan_multiscan[0] passes\n";
      print "</td></tr>\n";
    }

    /* colorspace data */
    if ($photo_data[25]!="") {
      global $icc_profiles;
      $photo_data[25] = $icc_profiles[$photo_data[25]]['name'];
      print "<tr><td align=\"right\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"25%\">Colorspace</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$photo_data[25]</td></tr>\n";
    }

    /* orientation data */
    if ($photo_data[26] != "") {
	$photo_data[26] = orientation_to_name($database, $photo_data[26]);
      print "<tr><td align=\"right\" valign=\"top\"
bgcolor=\"$color[table_top]\"  width=\"25%\">Transforms applied</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$photo_data[26]</td></tr>\n";
    }

    if ($photo_tech[17]!="") {
      print "<tr><td align=\"right\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"25%\">Support</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$support[0] $support[1] $support[2]</td></tr>\n";
    }
    /* custom exif data */
    if ($photo_tech[20]!="") {
      $trans = array("<key>" => "<tr><td align=\"right\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"25%\"><i>",
                     "</key><value>" => "</i></td><td align=\"left\" valign=\"top\"
 bgcolor=\"$color[table_body]\"><i>",
                     "</value>" => "</i></td></tr>\n");
      print strtr($photo_tech[20], $trans);
    }
    /* iptc data */
    if ($photo_tech[21]!="") {
      $photo_tech[21] = human_readable_iptc($photo_tech[21]);
      $trans = array("<key>" => "<tr><td align=\"right\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"25%\"><i>",
                     "</key><value>" => "</i></td><td align=\"left\" valign=\"top\"
 bgcolor=\"$color[table_body]\"><i>",
                     "</value>" => "</i></td></tr>\n");
      $photo_tech[21] = strtr($photo_tech[21], $trans);
      print $photo_tech[21];
    }
    print "<tr><td align=\"right\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"25%\"><a href=\"photo.php?photo=$photo_id&amp;order_by=$order_by&amp;detail_info=99\">Full EXIF dump</a></td>";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" > </td></tr>\n";

    print "</table>\n";
    break;
 case 99:
   $image_path = $image_repository_path . "/" . $photo_data[6];

   print "<table bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"4\" width=\"100%\">\n";

   if (is_executable($sys_exiftool)) {
     $handle = popen("$sys_exiftool $image_path", "r");
     if ($handle) {
       while (!feof($handle)) {
	 $line = fgets($handle);
	 $parts = explode(":", $line, 2);
	 $parts[0] = trim($parts[0]);
	 if (!isset($parts[1])) continue;
	 $parts[1] = trim($parts[1]);
	 if ($parts[0] == "File Name") continue;
	 if ($parts[0] == "Directory") continue;
	 if (substr($parts[1], 2, 6) == "Binary") continue;
	 print "<tr><td align=\"left\" valign=\"top\" bgcolor=\"$color[table_top]\" width=\"25%\">$parts[0]</td><td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\">$parts[1]</td></tr>\n";
       }
       pclose($handle);
     }
   } else {
     include('include/exif.php');

     $exif2 = read_exif_data_raw($image_path, 0);

     foreach ($exif2 as $key => $section) {
       if (is_array($section)) {
	 foreach ($section as $name => $val) {
	   if (!(strpos($name, 'unknown') === false)) continue;
	   if (!(strpos($name, 'RAWDATA') === false)) continue;
	   if (is_array($val)) {
	     foreach ($val as $name2 => $val2) {
	       if (!(strpos($name2, 'unknown') === false)) continue;
	       if (!(strpos($name2, 'RAWDATA') === false)) continue;
	       if (is_array($val2)) {
		 foreach ($val2 as $name3 => $val3) {
		   if (!(strpos($name3, 'unknown') === false)) continue;
		   if (!(strpos($name3, 'RAWDATA') === false)) continue;
		   print "<tr><td align=\"left\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"25%\">$key.$name.$name2.$name3</td>";
		   print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\">$val3</td></tr>\n";
		 }
	       } else {
		 print "<tr><td align=\"left\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"25%\">$key.$name.$name2</td>";
		 print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\">$val2</td></tr>\n";
	       }
	     }
	   } else {
	     print "<tr><td align=\"left\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"25%\">$key.$name</td>";
	     print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\">$val</td></tr>\n";
	   }
	 }
       } else {
	 print "<tr><td align=\"left\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"25%\">$key</td>";
	 print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\">$section</td></tr>\n";
       }
     }
   }
   print "</table>\n";

   break;
  case 3:
    $all_photo_dupes = pg_query($database, "
      select photo_dupe.identifier, key, date_of_creation, storage_location, storage_index, remark
        from photo_dupe
       where photo=$photo_id
       order by key");
    $photo_dupe_original = pg_fetch_row(pg_query($database, "
      select photo_dupe.identifier, key, date_of_creation, storage_location, storage_index, remark
        from photo_dupe
       where photo=$photo_id
         and remark='Original'"));
    $dupe_status = pg_fetch_row(pg_query($database, "
      select value
        from view_submission
       where photo_dupe=$photo_dupe_original[0]
       order by date_of_creation desc"));
    if (!$dupe_status) $dupe_status[0] ="Created";
    print "<table bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"4\" width=\"100%\">\n";
    print "<tr>\n";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"14%\">Dupe Identifier</td>";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"20%\">Creation Date</td>";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"15%\">Status</td>";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"15%\">Storage Location</td>";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"26%\">Remark</td>";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"10%\" colspan=\"2\"><a href=\"photo.dupe.add.php?photo=$photo_id\"><font >Add Dupe</font></a></td>\n";
    print "</tr>\n";
    print "<tr>\n";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$photo_id-$photo_dupe_original[1]</td>";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >".generate_date_html($photo_dupe_original[2], 'date', $po_user['id']  == "" ? 0 : 1)."</td>";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$dupe_status[0]</td>";
    if ($photo_dupe_original[4])
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$photo_dupe_original[3]-$photo_dupe_original[4]</td>";
    else
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$photo_dupe_original[3]</td>";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$photo_dupe_original[5]</td>";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\"  width=\"5%\">";
    print "<a href=photo.dupe.edit.php?photo=$photo_id&amp;dupe=$photo_dupe_original[0]>Edit</a></td>\n";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\"  width=\"5%\"></td>\n";
    print "</td>\n";
    print "</tr>\n";

    for ($i=0; $i < pg_num_rows($all_photo_dupes); $i++) {
      $photo_dupe = pg_fetch_row($all_photo_dupes, $i);
      $dupe_status = pg_fetch_row(pg_query($database, "
        select value
          from view_submission
         where photo_dupe=$photo_dupe[0]
         order by date_of_creation desc"));
      if (!$dupe_status) $dupe_status[0] ="Created";
      if ($photo_dupe[5] == "Original")
        continue;
      print "<tr>\n";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$photo_id-$photo_dupe[1]</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >".generate_date_html($photo_dupe[2], 'date', $po_user['id']  == "" ? 0 : 1)."</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$dupe_status[0]</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$photo_dupe[3]-$photo_dupe[4]</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$photo_dupe[5]</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\"  width=\"5%\">";
      print "<a href=photo.dupe.edit.php?photo=$photo_id&amp;dupe=$photo_dupe[0]>Edit</a></td>\n";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\"  width=\"5%\">";
      print "<a href=photo.dupe.del.php?photo=$photo_id&amp;dupe=$photo_dupe[0]>Delete</a></td>\n";
      print "</tr>\n";
    }
    print "</table>\n";
    break;
  case 4:
    $all_photo_dupes = pg_query($database, "
      select photo_dupe.identifier, key, date_of_creation, storage_location, storage_index, remark
        from photo_dupe
       where photo=$photo_id
       order by key");
    $photo_dupe_original = pg_fetch_row(pg_query($database, "
      select photo_dupe.identifier, key, date_of_creation, storage_location, storage_index, remark
        from photo_dupe
       where photo=$photo_id
         and remark='Original'"));
    print "<table bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"4\" width=\"100%\">\n";
    print "<tr>\n";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"14%\">Dupe Identifier</td>";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"20%\">Date</td>";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"15%\">Status</td>";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"41%\">Client, Remark</td>";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"10%\" colspan=\"2\"></td>\n";
    print "</tr>\n";
    print "<tr>\n";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_header]\" >$photo_id-$photo_dupe_original[1]</td>";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_header]\" >".generate_date_html($photo_dupe_original[2], 'date', $po_user['id']  == "" ? 0 : 1)."</td>";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_header]\" >Created</td>";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_header]\" >$photo_dupe_original[6]</td>";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_header]\"  colspan=2><a href=photo.submission.add.php?photo_dupe=$photo_dupe_original[0]>Add Record</a></td>\n";
    print "</td>\n";
    print "</tr>\n";
    $all_submissions = pg_query($database, "
      select identifier, uidentifier, first_name, last_name, value, date_of_creation, remark
        from view_submission
       where photo_dupe=$photo_dupe_original[0]");
    $num_of_submissions = pg_num_rows($all_submissions);
    if ($num_of_submissions > 0) {
      for ($i = 0; $i < $num_of_submissions; $i++) {
        $submission = pg_fetch_row($all_submissions, $i);
        print "<tr>\n";
        print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" ></td>";
        print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >".generate_date_html($submission[5], 'date', $po_user['id']  == "" ? 0 : 1)."</td>";
        print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$submission[4]";
        if ($submission[3] != "" && $submission[2] != "")
          $submission[3] = $submission[3] . ",";
        print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" ><a href=\"user.php?user=$submission[1]\">$submission[3] $submission[2]</a>";
        if ($submission[2] != "" && $submission[6] != "")
          $submission[6] = " - " . $submission[6];
        print "$submission[6]";
        print "</td>";
        print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\"  width=\"5%\">";
        print "<a href=photo.submission.edit.php?submission=$submission[0]>Edit</a></td>\n";
        print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\"  width=\"5%\">";
        print "<a href=photo.submission.del.php?submission=$submission[0]>Delete</a></td>\n";
        print "</tr>\n";
      }
    }

    for ($i=0; $i < pg_num_rows($all_photo_dupes); $i++) {
      $photo_dupe = pg_fetch_row($all_photo_dupes, $i);
      if ($photo_dupe[5] == "Original")
        continue;
      print "<tr>\n";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_header]\" >$photo_id-$photo_dupe[1]</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_header]\" >".generate_date_html($photo_dupe[2], 'date', $po_user['id']  == "" ? 0 : 1). "</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_header]\" >Created</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_header]\" >$photo_dupe[6]</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_header]\"  colspan=2><a href=photo.submission.add.php?photo_dupe=$photo_dupe[0]>Add Record</a></td>\n";
      print "</tr>\n";
      $all_submissions = pg_query($database, "
        select identifier, uidentifier, first_name, last_name, value, date_of_creation, remark
          from view_submission
         where photo_dupe=$photo_dupe[0]");
      $num_of_submissions = pg_num_rows($all_submissions);
      if ($num_of_submissions > 0) {
        for ($j = 0; $j < $num_of_submissions; $j++) {
          $submission = pg_fetch_row($all_submissions, $j);
          print "<tr>\n";
          print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" ></td>";
          print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >".generate_date_html($submission[5], 'date', $po_user['id']  == "" ? 0 : 1). "</td>";
          print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$submission[4]";
          if ($submission[3] != "" && $submission[2] != "")
            $submission[3] = $submission[3] . ",";
          print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" ><a href=\"user.php?user=$submission[1]\">$submission[3] $submission[2]</a>";
          if ($submission[2] != "" && $submission[6] != "")
            $submission[6] = " - " . $submission[6];
          print "$submission[6]";
          print "</td>";
          print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\"  width=\"5%\">";
          print "<a href=photo.submission.edit.php?submission=$submission[0]>Edit</a></td>\n";
          print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\"  width=\"5%\">";
          print "<a href=photo.submission.del.php?submission=$submission[0]>Delete</a></td>\n";
          print "</tr>\n";
        }
      }
    }
    print "</table>\n";
    break;
  case 5:
    $photo_version_master = pg_fetch_row(pg_query($database, "
      select identifier, key, date_of_creation, comment, original_image_name, large_image_path
        from photo_version
       where photo=$photo_id
         and master='t'"));
    $bgcolor = (($version == "") || ($photo_version_master[0] == $version)) ? $color['selected'] : $color['table_body'];
    print "<table bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"4\" width=\"100%\">\n";
    print "<tr>\n";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"14%\">Version</td>";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"18%\">Date</td>";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"6%\">Master</td>";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"32%\">Remark</td>";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"7%\">File Name</td>";

    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"6%\">Dimension</td>";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"5%\">Size</td>";

    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"10%\" colspan=\"2\"><a href=\"photo.version.add.php?photo=$photo_id\"><font >Add Version</font></a></td>\n";
    print "</tr>\n";
    print "<tr>\n";
    $on_mouse_over ="ttOffsetX=12; ttWidth=10; return escape('<img src=image.display.php?image=$photo_id&amp;size=1&amp;ver=$photo_version_master[0] border=0')";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$bgcolor\" ><a href=photo.php?photo=$photo_id&amp;detail_info=5&amp;ver=$photo_version_master[0] onmouseover=\"$on_mouse_over\" />$photo_id-V.$photo_version_master[1]</a></td>";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$bgcolor\" >".generate_date_html($photo_version_master[2], 'date', $po_user['id']  == "" ? 0 : 1)."</td>";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$bgcolor\" >Yes</td>";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$bgcolor\" >$photo_version_master[3]</td>";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$bgcolor\" >$photo_version_master[4]</td>";

    error_reporting(0);
    $image_dimension = po_get_image_size($image_repository_path."/".$photo_version_master[5], $info);
    $image_size = filesize($image_repository_path."/".$photo_version_master[5]) / 1024;
    if ($image_size < 1024) {
      $image_size = round($image_size);
      $image_size_string = "$image_size Kb";
    }
    else {
      $image_size /=1024;
      $image_size = round($image_size);
      $image_size_string = "$image_size Mb";
    }
    error_reporting(1);

    print "<td align=\"left\" valign=\"top\" bgcolor=\"$bgcolor\" >$image_dimension[0]x$image_dimension[1]</td>";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$bgcolor\" >$image_size_string</td>";

    print "<td align=\"left\" valign=\"top\" bgcolor=\"$bgcolor\"  width=\"5%\"><a href=photo.version.edit.php?photo=$photo_id&amp;version=$photo_version_master[0]>Edit</a></td>\n";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$bgcolor\"  width=\"5%\"></td>\n";
    print "</td>\n";
    print "</tr>\n";

    $all_photo_versions = pg_query($database, "
      select identifier, key, date_of_creation, comment, original_image_name, large_image_path, master
        from photo_version
       where photo=$photo_id
       order by key");
    for ($i=0; $i < pg_num_rows($all_photo_versions); $i++) {
      $photo_version = pg_fetch_row($all_photo_versions, $i);
      if ($photo_version[6] == 't')
        continue;
      $bgcolor = $photo_version[0] == $version ? $color['selected'] : $color['table_body'];
      print "<tr>\n";
      $on_mouse_over ="ttOffsetX=12; ttWidth=10; return escape('<img src=image.display.php?image=$photo_id&amp;size=1&amp;ver=$photo_version[0] border=0')";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$bgcolor\" ><a href=photo.php?photo=$photo_id&amp;detail_info=5&amp;ver=$photo_version[0] onmouseover=\"$on_mouse_over\">$photo_id-V.$photo_version[1]</a></td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$bgcolor\" >".generate_date_html($photo_version[2], 'date', $po_user['id']  == "" ? 0 : 1)."</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$bgcolor\" >No</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$bgcolor\" >$photo_version[3]</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$bgcolor\" >$photo_version[4]</td>";

      error_reporting(0);
      $image_dimension = po_get_image_size($image_repository_path."/".$photo_version[5], $info);
      $image_size = filesize($image_repository_path."/".$photo_version[5]) / 1024;
      if ($image_size < 1024) {
        $image_size = round($image_size);
        $image_size_string = "$image_size Kb";
      }
      else {
        $image_size /=1024;
        $image_size = round($image_size);
        $image_size_string = "$image_size Mb";
      }
      error_reporting(1);

      print "<td align=\"left\" valign=\"top\" bgcolor=\"$bgcolor\" >$image_dimension[0]x$image_dimension[1]</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$bgcolor\" >$image_size_string</td>";

      print "<td align=\"left\" valign=\"top\" bgcolor=\"$bgcolor\"  width=\"5%\">";
      print "<a href=photo.version.edit.php?photo=$photo_id&amp;version=$photo_version[0]>Edit</a></td>\n";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$bgcolor\"  width=\"5%\">";
      print "<a href=photo.version.del.php?photo=$photo_id&amp;version=$photo_version[0]>Delete</a></td>\n";
      print "</tr>\n";
    }
    print "</table>\n";
    break;
  case 6:
    $average_rating = pg_fetch_row(pg_query($database, "select avg(value) from rating where photo=$photo_id"));
    if ($average_rating[0] == "") {
      $average_rating = "";
    }
    else {
      $average_rating = round($average_rating[0], 3);
    }
    print "<table bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"4\" width=\"100%\">\n";
    print "<tr>\n";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"10%\">Rating";
    if ($average_rating != "")
      print ": <b>$average_rating</b>";
    print "</td>";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"40%\">Comment</td>";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"20%\">User</td>";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"20%\">Date</td>";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"10%\" colspan=\"2\">";
    if ($po_user['id']!="") {
      $my_rating = pg_fetch_row(pg_query($database, "
        select identifier, date_of_creation, value, comment
          from rating
         where photo = $photo_id
           and users = $po_user[id]"));
      if ($my_rating == "") {
        print "<a href=photo.rating.add.php?photo=$photo_id><font >Rate</font></a>\n";
      }
    }
    print "</td></tr>\n";
    if ($my_rating) {
      print "<tr>\n";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$my_rating[2]</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$my_rating[3]</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" ><a href=\"user.php?user=$po_user[id]\">Myself</a></td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >".generate_date_html($my_rating[1], 'date', $po_user['id']  == "" ? 0 : 1)."</td>";
      if ($po_user['id']!="") {
        print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\"  width=\"5%\">";
        print "<a href=photo.rating.edit.php?photo=$photo_id&amp;rating=$my_rating[0]>Edit</a></td>\n";
        print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\"  width=\"5%\">";
        print "<a href=photo.rating.del.php?photo=$photo_id&amp;rating=$my_rating[0]>Delete</a></td>\n";
      }
      print "</tr>\n";
    }

    $all_ratings = pg_query($database, "
      select identifier, users, date_of_creation, value, first_name, last_name, comment
        from view_rating
       where photo=$photo_id
       order by date_of_creation");
    for ($i=0; $i < pg_num_rows($all_ratings); $i++) {
      $rating = pg_fetch_row($all_ratings, $i);
      if ($rating[1] == $po_user['id'])
        continue;
      print "<tr>\n";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$rating[3]</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$rating[6]</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" ><a href=\"user.php?user=$rating[1]\">$rating[4] $rating[5]</a></td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >".generate_date_html($rating[2], 'date', $po_user['id']  == "" ? 0 : 1)."</td>";
      print "<td align=\"center\" valign=\"top\" bgcolor=\"$color[table_body]\" ></td>\n";
      print "<td align=\"center\" valign=\"top\" bgcolor=\"$color[table_body]\" ></td>\n";
      print "</tr>\n";
    }
    print "</table>\n";
  break;
  case 7:
    if (strncmp($photo_data[24], "http", 4) == 0)
      $photo_data[24] = "<a href=\"".$photo_data[24]."\">".$photo_data[24]."</a>";

    print "<table bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"4\" width=\"100%\">\n";
    print "<tr><td align=\"right\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"10%\">Statement</td>";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$photo_data[9]</td></tr>\n";
    print "<tr><td align=\"right\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"10%\">Web Statement</td>";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$photo_data[24]</td></tr>\n";
    print "</table>\n";
  break;
  case 8:
    if ($po_user['id'] == $owner_id || $po_user['type'] == $user_type['administrator']) {
      $owner = TRUE;
      $cellpadding = 6;
    }
    else {
      $owner = FALSE;
      $cellpadding = 4;
    }
    print "<table bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"$cellpadding\" width=\"100%\">\n";
    print "<tr>\n";
    if (!$owner) {
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"10%\">Select</td>\n";
    }
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"15%\">Category</td>";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"15%\">Item</td>";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"35%\">Remark</td>";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"10%\">Price</td>";
    print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"15%\">Date</td>";
    if ($owner) {
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_top]\"  width=\"10%\" colspan=\"2\">";
      print "<a href=\"photo.item.add.php?photo=$photo_id\"><font >Add</font></a></td>\n";
    }
    print "</tr>\n";

    $none_checked = TRUE;
    for ($i=0; $i < $number_of_photos_for_sale; $i++) {
      $photo_for_sale = pg_fetch_row($all_photo_items_for_sale, $i);
      if (($photo_for_sale[13] == 't') && (!$owner))
        continue;

      print "<tr>\n";
      if (!$owner) {
        if ($photo_for_sale[9]) {
          $checked = " checked ";
          $none_checked = FALSE;
        }
        else {
          $checked = "";
        }

        print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\"  width=\"10%\"><input type=\"checkbox\" name=\"cb$photo_for_sale[0]\" $checked/></td>\n";
      }
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" nowrap>$photo_for_sale[8]</a></td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" nowrap>$photo_for_sale[2]</a></td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$photo_for_sale[5]";
      /* if the client is trusted or the shop_transaction was aproved */
      if ($photo_for_sale[12]) {
        if (is_numeric($photo_for_sale[10])) {
          print ", $photo_for_sale[10] downloads left";
          if ($photo_for_sale[11]) {
            print ", expires at ".generate_date_html($photo_for_sale[11], 'date', $po_user['id']  == "" ? 0 : 1);
          }
        }
      }
      print "</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >$photo_for_sale[4] $photo_for_sale[3]</td>";
      print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\" >".generate_date_html($photo_for_sale[6], 'date', $po_user['id']  == "" ? 0 : 1)."</td>";
      if ($owner) {
        print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\"  width=\"5%\">";
        print "<a href=photo.item.edit.php?photo=$photo_id&amp;item=$photo_for_sale[0]>Edit</a></td>\n";
        print "<td align=\"left\" valign=\"top\" bgcolor=\"$color[table_body]\"  width=\"5%\">";
        if ($photo_for_sale[13] == 'f') {
          print "<a href=photo.item.del.php?photo=$photo_id&amp;item=$photo_for_sale[0]>Delete</a></td>\n";
        }
        else {
          print "<a href=photo.item.del.2.php?photo=$photo_id&amp;item=$photo_for_sale[0]&amp;op=undel>Undelete</a></td>\n";
        }
      }
      print "</tr>\n";
    }
    print "</table>\n";
}

if ($po_user['id'] == $owner_id || $po_user['type'] == $user_type['administrator']) {
  print "<input type=\"hidden\" name=\"detail_info\" value=\"$detail_info\"/>";
  print "<table align=\"left\" valign=\"middle\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\" width=\"100%\">";
  print "<tr><td>";
  print "<table align=\"left\" valign=\"middle\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\">";
  print "<tr>";
  if ($po_user['id'] == $owner_id || $po_user['type'] == $user_type['administrator']) {
    print "<td align=\"left\" valign=\"middle\">";
    display_printto();
    print "</td>\n";
    print "<td align=\"left\" valign=\"middle\">&nbsp;&nbsp;</td>";
    print "<td align=\"left\" valign=\"middle\">";
    display_export();
    print "</td>";
    print "<td align=\"left\" valign=\"middle\">&nbsp;&nbsp;</td>";
  }
  print "<td align=\"left\" valign=\"middle\">";
  display_transform($photo_id);
  print "</td>";
  if ($detail_info != 6 && $detail_info != 5 && $detail_info != 4 && $detail_info != 3) {
    print "<td align=\"left\" valign=\"middle\">&nbsp;&nbsp;</td>";
    print "<td align=\"left\" valign=\"middle\">\n";
    print "<a class=\"nodecor\" href=\"photo.edit.php?photo=$photo_id\"><img src=\"$theme/button.edit.gif\" alt=\"Edit\" border=\"0\"/></a>\n";
    print "</td>\n";
  }
  print "<td align=\"left\" valign=\"middle\">&nbsp;&nbsp;</td>";
  print "<td align=\"left\" valign=\"middle\">\n";
  print "<input type=\"image\" src=\"$theme/button.set.as.watermark.gif\" name=\"set_as_watermark\" value=\"please\"/>\n";
  print "</td>\n";

  print "</tr>";
  print "</table>";

  print "</td><td align=\"right\" valign=\"middle\">\n";
  display_order_by_combo_for_photo($order_by, $album_id, $previous, $photo_id, $next, $detail_info);
  print "</td></tr><tr><td colspan=\"2\">";

  print "<table align=\"left\" valign=\"middle\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\">";
  print "<tr>";
  print "<td align=\"left\" valign=\"middle\">";
  display_moveto_folder($folder_all, $photo_data[1], "goto");
  print "</td>";
  print "<td align=\"left\" valign=\"middle\">&nbsp;&nbsp;</td>";
  print "<td align=\"left\" valign=\"middle\">";
  display_moveto_folder($folder_all, $photo_data[1], "moveto");
  print "</td>";
  if (pg_num_rows($album_all) > 0) {
    print "<td align=\"left\" valign=\"middle\">&nbsp;&nbsp;</td>";
    print "<td align=\"left\" valign=\"middle\">";
    display_linkto_album($album_all, "");
    print "</td>";
  }

  print "</tr>";
  print "</table>";

  print "</td></tr>";
  print "</table>";
}
elseif (($po_user['type'] >= $user_type['client']) && ($detail_info == 8)) {
  if ($number_of_photos_for_sale > 0) {
    print "<input type=\"hidden\" name=\"basket\" value=\"yes\"/>";
    print "<input type=\"hidden\" name=\"detail_info\" value=\"8\"/>";
    if ($none_checked)
      print "<input type=\"image\" src=\"$theme/button.put.selection.to.basket.gif\" alt=\"Put Selection to Basket\"/>\n";
    else
      print "<input type=\"image\" src=\"$theme/button.update.basket.gif\" alt=\"Update Basket\"/>\n";
  }
  print "<a class=\"nodecor\" href=\"basket.php\"><img src=\"$theme/button.view.basket.gif\" alt=\"View Basket\" border=\"0\"/></a>\n";
}
print "</form>\n";

print "<script language=\"JavaScript\" type=\"text/javascript\" src=\"javascript/wz_tooltip.js\"></script>";
site_footer($database);
site_epilog($database);
?>
