--  Copyright (C) 2006 Solomon Peachy (pizza@shaftnet.org)

--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 2 of the License, or
--  (at your option) any later version.

--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.

--  You should have received a copy of the GNU General Public License
--  along with this program; if not, write to the Free Software
--  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

----------------------------------------------------------
-- v2.32 to v2.33 patch
----------------------------------------------------------

-- Split out keywords...

create table photo_keywords (
	photo integer not null references photo(identifier),	
	keyword text not null
);
create index photo_keywords_photo on photo_keywords(photo);

-- This is called by the upgrade script --
-- alter table photo drop keyword;

-- And rename a column...

alter table location rename last_modifying_users to users;

alter table location add private boolean;
update location set private='f';
alter table location alter private set not null;

drop view view_location;

create view view_location as
  select location.identifier, location.place, location.city,
         (select value from state where state.identifier=location.state) as state,
         (select value from country where country.identifier=location.country) as country,
         users, last_modified_date,
         latitude, longitude, private
    from location;

-- Add another column to the filters
alter table filter add serial_number varchar(20);

-- Additional indexing

create index photo_version_photo_idx           on photo_version(photo);
create index client_client_idx    on client(client);
create index client_users_idx    on client(users);
